(function() {
  var ScriptPlay,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  ScriptPlay = (function() {
    function ScriptPlay() {
      this.prev = bind(this.prev, this);
      this.next = bind(this.next, this);
      this.update_classes = bind(this.update_classes, this);
      this.set_bubble = bind(this.set_bubble, this);
      this.app = $('section.viewer');
      this.scripts = $('div.script div');
      this.bubble = $('#bubble');
      this.characters = $('.character');
      this.fox = $('.character.fox');
      this.mrsfox = $('.character.mrsfox');
      this.ash = $('.character.ash');
      this.button_next = $('i.next');
      this.button_prev = $('i.prev');
      this.current = 0	;
      this.count = this.scripts.length;
      this.button_next.on('click', this.next);
      this.button_prev.on('click', this.prev);
    this.set_bubble(0);
    }

    ScriptPlay.prototype.set_bubble = function(num) {
      var new_class;
      this.bubble.html(this.scripts.eq(num - 1).html());
      new_class = this.scripts.eq(num - 1).attr('class');
      this.update_classes(new_class);
      this.current = num;
      this.button_next.removeClass('disable');
      this.button_prev.removeClass('disable');
      if (this.current <= 1) {
        return this.button_prev.addClass('disable');
      } else if (this.current === this.count) {
        return this.button_next.addClass('disable');
      }
    };

    ScriptPlay.prototype.update_classes = function(newclass) {
		if(!GoFade){
		  this.bubble.attr('class', '');
		  this.bubble.addClass(newclass);
		  this.characters.addClass('inactive');
		  if (newclass.indexOf("mrsfox") !== -1) {
			return this.mrsfox.removeClass('inactive');
		  } else if (newclass.indexOf("fox") !== -1) {
			return this.fox.removeClass('inactive');
		  } else if (newclass.indexOf("ash") !== -1) {
			return this.ash.removeClass('inactive');
		  }
		}
    };

    ScriptPlay.prototype.next = function(e) {
		$('#bubble').css('display','block')
		
		if(Play_){
			GoFade = false;
		//$('#ReadMe').css('visibility','visible')
		  e.preventDefault();
		  if(Auto_Play){//alert(this.current)
		  if(this.current==this.count && TheEnd){
		  	this.current = 0;
			TheEnd = false;
		  }
			  isFirst = false;
			  this.current = this.current;
			//  alert()
			  if (this.current < this.count) {
					
				  $('.character.fox').attr('src',charc_2[this.current])		  
				  $('.character.mrsfox').attr('src',charc_1[this.current])	 
				  			  
					var SOUND = soundManager.createSound({url:Sounds[this.current],id:Sounds[this.current]+'_s',onfinish:function(){
						$('i.next').click();
					}});					
					SOUND.play();	
			ThisCurr = this.current;
				 //	this.current = this.current - 2;
				return this.set_bubble(this.current + 1);
			  }
			  else{//alert(559)
				  if(Auto_Play){	
				  Auto_Play = false;	  
					$('#play_ch').css('display','inline-block');
					$('#stop_ch').css('display','none');
					$('i.next, i.prev').css('visibility','visible');
					$('i.prev').addClass('disable');
					$('i.next').removeClass('disable');

					$('#ReadMe').css('visibility','hidden')
		
					$('#bubble').fadeOut();
					this.current = 0
					//alert()
					ThisCurr = this.current;
					
					$('.character.fox').addClass('inactive')		
					$('.character.mrsfox').addClass('inactive')	
		
					isFirst = true;	
				  }
			  }			  
						  
		  }
		  else{
			  if (this.current < this.count) {
					$('#ReadMe').css('visibility','visible')
				  //alert(this.current)
		/*		  $('.character.fox').attr('src',charc_2[this.current+1])	  		  
				  $('.character.mrsfox').attr('src',charc_1[this.current+1])*/
		soundManager.stopAll();
				  
			$('#ReadMe').removeClass('fa-volume-up').addClass('fa-volume-off').css('color','#2e55c2');
			
				
								
				  $('.character.fox').attr('src',charc_2[this.current])	 			  
				  $('.character.mrsfox').attr('src',charc_1[this.current])
				  	
					ThisCurr = this.current;
					var tmpr = this.current;
					
				if(this.current==this.count-1){
					//Auto_Play = true;
					this.current = 0;
					TheEnd = true
					
				}
					
				return this.set_bubble(tmpr + 1);
			  }
			  else{
				  //	if(this.current==(dialog.length)){
						//alert(dialog.length)
					 // this.current = 1;
					//}				  
				  if(Auto_Play){	
				  Auto_Play = false;	  
					$('#play_ch').css('display','inline-block');
					$('#stop_ch').css('display','none');
					$('i.next, i.prev').css('visibility','visible');
					//this.current = 1
					
					isFirst = true;	
				  }
			  }
		}
					
			}
		};

    ScriptPlay.prototype.prev = function(e) {
$('#bubble').css('display','block')
		
      e.preventDefault();
	//  alert()
      if (this.current > 1) {//alert(this.current-2)
			$('#ReadMe').removeClass('fa-volume-up').addClass('fa-volume-off').css('color','#2e55c2');
		soundManager.stopAll();
	  
	  TheEnd = false;

						  
				  $('.character.fox').attr('src',charc_2[this.current-2])
				  $('.character.mrsfox').attr('src',charc_1[this.current-2])
		ThisCurr = this.current - 2;

        return this.set_bubble(this.current - 1);
      }
	    };

    return ScriptPlay;

  })();

  $(function() {
    return new ScriptPlay();
  });

}).call(this);