﻿var rand_word_top = 20;
var rand_word_left = 10;
var rand_word_right = 10;
var rand_word_bottom = 10;

var shadow = '-webkit-box-shadow: 2px 2px 6px rgba(0,0,0,0.6); -moz-box-shadow: 2px 2px 6px rgba(0,0,0,0.6); box-shadow: 2px 2px 6px rgba(0,0,0,0.6);';
var rotate = '-webkit-transform: rotate(-5deg); -moz-transform: rotate(-5deg); -o-transform: rotate(-5deg);';
var skew = '-webkit-transform: skew(5deg,5deg); -moz-transform: skew(5deg,5deg); -o-transform: skew(5deg,5deg);';
var types = new Array('',
	'box border1','box border2','box border3','box border5','box border6','box border7','box border7','box border7','box border7','box border7','round1','round2','round3','drop-shadow lifted','drop-shadow curled','drop-shadow perspective','drop-shadow raised','drop-shadow curved curved-vt-1','drop-shadow curved curved-vt-2','drop-shadow curved curved-hz-1','drop-shadow curved curved-hz-2','drop-shadow lifted rotated','css5box1','css5box2','css5box3','css5box4','gradback','gradpicback','tack-box','shadow-box','border-box','alpha-box','grad-box','fader','page');
var shadows = new Array('',
	'-webkit-box-shadow:0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;-moz-box-shadow:0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;box-shadow:0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;',
	'-webkit-box-shadow:0 10px 10px rgba(0, 0, 0, 0.7);-moz-box-shadow:0 10px 10px rgba(0, 0, 0, 0.7);box-shadow:0 10px 10px rgba(0, 0, 0, 0.7);',
	'-webkit-box-shadow:0 8px 12px rgba(0, 0, 0, 0.5);-moz-box-shadow:0 8px 12px rgba(0, 0, 0, 0.5);box-shadow:0 8px 12px rgba(0, 0, 0, 0.5);',
	'-webkit-box-shadow:-10px 0 8px rgba(0, 0, 0, 0.4);-moz-box-shadow:-10px 0 8px rgba(0, 0, 0, 0.4);box-shadow:-10px 0 8px rgba(0, 0, 0, 0.4);',
	'-webkit-box-shadow: 0 15px 10px -10px rgba(0, 0, 0, 0.5), 0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;-moz-box-shadow: 0 15px 10px -10px rgba(0, 0, 0, 0.5), 0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;box-shadow: 0 15px 10px -10px rgba(0, 0, 0, 0.5), 0 1px 4px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;',
	'-webkit-box-shadow:0 0 15px rgba(0,0,0,0.6);-moz-box-shadow:0 0 15px rgba(0,0,0,0.6);box-shadow:0 0 15px rgba(0,0,0,0.6);',
	'-webkit-box-shadow:0 5px 10px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;-moz-box-shadow:0 5px 10px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;box-shadow:0 5px 10px rgba(0, 0, 0, 0.3), 0 0 40px rgba(0, 0, 0, 0.1) inset;',
	'box-shadow: 0px 1px 3px rgba(0,0,0,0.7);-webkit-box-shadow: 0px 1px 3px rgba(0,0,0,0.7);-moz-box-shadow: 0px 1px 3px rgba(0,0,0,0.7);',
	'box-shadow: 5px 5px 5px #888;-webkit-box-shadow: 5px 5px 5px #888;-moz-box-shadow: 5px 5px 5px #888;',
	'-webkit-box-shadow: 0 2px 10px 1px rgba(0,0,0,.2);-moz-box-shadow: 0 2px 10px 1px rgba(0,0,0,.2);box-shadow: 0 2px 10px 1px rgba(0,0,0,.2);'
);

document.write('<style type="text/css">');
document.write('*{margin:0;padding:0;outline:none;}');
document.write('html{overflow-y:scroll;}');
document.write('body{visibility:hidden;}');
if(MyType=='s'){
	document.write('body{background: #FFFFFF;}');
}
if(MyType=='ub'){
	document.write('body{background: #abc3e1 url('+CurDir+'bg_blueprint.png) repeat;}');
}
if(MyType=='ug'){
	document.write('body{background: #d5d5d5 url('+CurDir+'bg_blueprint.png) repeat;}');
}
document.write('#template_container{font-family:"'+template_font+'";margin-top:0px;width:750px;position:relative;margin:0 auto;height:100%;}');
document.write('.title_div{direction:'+MyDir+';margin-top:'+title_top+'px;margin-left:'+title_left+'px;margin-right:'+title_right+'px;margin-bottom:'+title_bottom+'px;font-size:'+title_size+'px;text-align:'+title_align+';color:'+title_color+';}');
document.write('.fb_div{position:absolute;top:0px left:25px;width:700px;direction:'+MyDir+';margin-top:'+fb_top+'px;margin-left:'+fb_left+'px;margin-right:'+fb_right+'px;margin-bottom:'+fb_bottom+'px;font-size:'+fb_size+'px;text-align:'+fb_align+';color:'+fb_color+';}');
document.write('.data{direction:'+MyDir+';margin-top:'+data_top+'px;margin-left:'+data_left+'px;margin-right:'+data_right+'px;margin-bottom:'+data_bottom+'px;font-size:'+data_size+'px;text-align:'+data_align+';color:'+data_color+';');
/*if(navigator.userAgent.indexOf('MSIE 7.0')!=-1){
	document.write('line-height:'+data_size+'px;');
}
else{*/
	document.write('line-height:'+(data_size+10)+'px;');
/*}*/
document.write('}');
document.write('input{direction:'+MyDir+';font-size:'+data_size+'px;text-align:'+data_align+';color:'+data_color+';}');
document.write('.rand_word{direction:'+MyDir+';margin-top:'+rand_word_top+'px;margin-left:'+rand_word_left+'px;margin-right:'+rand_word_right+'px;margin-bottom:'+rand_word_bottom+'px;font-size:'+rand_word_size+'px;text-align:'+rand_word_align+';color:'+rand_word_color+';}');
document.write('#rand_word{min-height:'+randword_min_height+'px; visibility:hidden; }');
document.write('#texts_words{ visibility:hidden; }');
document.write('.make_container{direction:'+MyDir+';');
document.write('width:'+(750-border_width*2)+'px;');
document.write('min-height:'+cont_min_height+'px;');
document.write('margin:0 auto;');
document.write('border:'+border_width+'px '+border_style+' '+border_color+';');
document.write('background:'+bg_color+' url('+bg_img+') repeat;');
document.write(shadows[shadows_id]);
document.write('-webkit-border-radius: '+radius_top_left_top+'px '+radius_top_right_top+'px '+radius_bottom_right_bottom+'px '+radius_bottom_left_bottom+'px / '+radius_top_left_left+'px '+radius_top_right_right+'px '+radius_bottom_right_right+'px '+radius_bottom_left_left+'px;');
document.write('-moz-border-radius: '+radius_top_left_top+'px '+radius_top_right_top+'px '+radius_bottom_right_bottom+'px '+radius_bottom_left_bottom+'px / '+radius_top_left_left+'px '+radius_top_right_right+'px '+radius_bottom_right_right+'px '+radius_bottom_left_left+'px;');
document.write('border-radius: '+radius_top_left_top+'px '+radius_top_right_top+'px '+radius_bottom_right_bottom+'px '+radius_bottom_left_bottom+'px / '+radius_top_left_left+'px '+radius_top_right_right+'px '+radius_bottom_right_right+'px '+radius_bottom_left_left+'px;}');
document.write('.worda{width:'+img_width+'px;height:'+img_height+'px;border:1px solid '+data_color+';text-align:'+true_answ_align+';background:'+img_bg_color+';');
/* if(navigator.userAgent.indexOf('MSIE 7.0')!=-1){
	document.write('display:inline;');
}
else{ */
	document.write('display:inline-block;');
/* } */
document.write('}');
document.write('.hover{border:1px solid '+line_hover_color+';}');
document.write('.draggable {width:'+img_width+'px;height:'+img_height+'px;cursor: move;}');
document.write('</style>');
if(info_icon){
	if(MyDir=='rtl'){
		document.write('<img title="'+info_img_tip+'" src="'+info_img+'" style="cursor:pointer;position:absolute;top:'+info_img_top+'px;left:'+info_img_left_right+'px;" onMouseover="$(\'#info\').fadeIn();" onMouseout="$(\'#info\').fadeOut();">');
		document.write('<div id="info" style="display:none;width:'+info_text_width+'px;position:absolute;top:'+info_text_top+'px;left:'+info_text_left_right+'px;background:'+info_text_bg+';color:'+info_color+';font-size:'+info_size+'px;z-index:9999;text-align:'+info_align+';"><div class="info_text" style="margin:10px;">'+text_info+'</div></div>');
	}
	if(MyDir=='ltr'){
		document.write('<img title="'+info_img_tip+'" src="'+info_img+'" style="cursor:pointer;position:absolute;top:'+info_img_top+'px;right:'+info_img_left_right+'px;" onMouseover="$(\'#info\').fadeIn();" onMouseout="$(\'#info\').fadeOut();">');
		document.write('<div id="info" style="display:none;width:'+info_text_width+'px;position:absolute;top:'+info_text_top+'px;right:'+info_text_left_right+'px;background:'+info_text_bg+';color:'+info_color+';font-size:'+info_size+'px;z-index:9999;text-align:'+info_align+';"><div class="info_text" style="margin:10px;">'+text_info+'</div></div>');

	}
}
document.write('<div id="title"><div class="title_div">'+title+'</div></div>');
var style_style = '';
var nb_words = data.split('[:').length-1;

var rand_word = new Array();
var data_rep = data;
for(var i=0;i<nb_words;i++){
	data_rep = data_rep.replace('[:','<div class="worda" id="word'+i+'-a">');
	data_rep = data_rep.replace(':]','</div>');
}
var body_html = data_rep;
if(type_id!=0){
	if(type_id==8){style_style=shadow}
	if(type_id==9){style_style=rotate}
	if(type_id==10){style_style=skew}
		document.write('<div class="'+types[type_id]+'" style="'+style_style+'" id="rand_word"><div class="rand_word"></div></div>');
		document.write('<div style="height:'+distance_between_cont+'px;"></div>');
		document.write('<div class="'+types[type_id]+'" style="'+style_style+'" id="texts_words"><div class="data"><div style="padding-right:1px;">'+body_html+'</div></div></div>');
}
else{
		document.write('<div class="make_container" id="rand_word"><div class="rand_word"></div></div>');
		document.write('<div style="height:'+distance_between_cont+'px;"></div>');
		document.write('<div class="make_container" id="texts_words"><div class="data"><div style="padding-right:1px;">'+body_html+'</div></div></div>');
}
$(document).ready(function(){
	$('.worda').each(function(){
		rand_word.push($(this).html());
		$(this).attr({'data':$(this).html().split('-')[0]}).html('&nbsp;');
	})
	$('#texts_words').css({'visibility':'visible'});
	$('#rand_word').css({'visibility':'visible'});
	$('body').css({'visibility':'visible'});
	var words_opt = rand_word;
	var words_opt_filtered = new Array();
	var words_opt_fil_nb = new Array();

	for(var l=0;l<words_opt.length;l++){
		if(words_opt[l]!=''){
			words_opt_filtered[l] = words_opt[l];
			words_opt_fil_nb[l] = 0;
			for(var n=l;n<words_opt.length;n++){
				if(words_opt[n]!=''){
					if(words_opt[n]==words_opt_filtered[l]){
						words_opt_fil_nb[l]++;
						words_opt[n]="";
					}
				}
			}
		}
	}
	var opt_joined = new Array();
	for(var d=0;d<words_opt_filtered.length;d++){
		if(words_opt_filtered[d]!=null && words_opt_filtered[d]!='')
		opt_joined[d] = words_opt_filtered[d]+';;'+words_opt_fil_nb[d];
	}
	var option_rand = opt_joined.sort( randOrd );
	var radom_word = '<table id="random_word_table" border="0" cellpadding="0" cellspacing="0" width="100%" align="center" style="text-align:center;">';
	for(var j=0;j<option_rand.length;j=j+rand_word_per_line){
		radom_word += '<tr>';
		for(var k=j;k<j+rand_word_per_line;k++)	{
			if(option_rand[k]!=null){
				radom_word += '<td>';
					radom_word += '<div id="word'+k+'-b" class="draggable ui-draggable" style="text-align:'+rand_word_align+';top:0px;left:0px;" exist="'+option_rand[k].split(';;')[1]+'" used="0"><img src="'+option_rand[k].split(';;')[0].split('-')[1]+'" src2="'+option_rand[k].split(';;')[0].split('-')[0]+'" width="'+img_width+'" height="'+img_height+'"';
					if(MyDir=='ltr')radom_word += 'title="'+option_rand[k].split(';;')[0].split('-')[1].split('.')[0].replace('_',' ')+'"';
					radom_word += '/></div>';
				radom_word += '</td>';
			}
			else{
				radom_word += '<td></td>';
			}
		}
		radom_word += '</tr>';
	}
	radom_word += '</table>';
	$('.rand_word').html(radom_word);
	for(var j=0;j<option_rand.length;j++){
		$('#word'+j+'-b').draggable({
            zIndex: 9999,
			stop: function(){
				if($(this).css('top')!='0px' || $(this).css('left')!='0px'){
					$(this).animate( {
						top:     0,
						left:     0
					} ).draggable( 'option', 'revert', true );
					setTimeout( function() {
						$(this).draggable( 'option', 'revert', false );
					}, 100 );
				}
			}
		});
	}
});
var true_choice = 0;
$('.data div').find( '.worda' ).droppable( {
	accept:     '.draggable',
	hoverClass: 'hover',
	drop: function( e, ui ) {
		var modelLetter      = $( this ).attr('id'),
			droppedLetter = ui.helper.attr('id');
			var each_left = $( this ).offset().left;
		if ( $('#'+modelLetter).attr('data') == $('#'+droppedLetter).find('img').attr('src2') ) {
			$('#'+modelLetter).css({'background':'transparent url('+$('#'+droppedLetter).find('img').attr('src')+') top center no-repeat'});
			$('#'+modelLetter).attr({'title':$('#'+droppedLetter).find('img').attr('title')});
			if(navigator.userAgent.indexOf('MSIE 9.0')==-1)setTimeout('playsound("snd_true.mp3")',100);
			true_choice++;
			var used_times = parseInt($('#'+droppedLetter).attr('used'));
			var exist_times = parseInt($('#'+droppedLetter).attr('exist'));
			used_times++;
			$('#'+droppedLetter).css({'visibility':'hidden'});
			ui.draggable.draggable( 'option', 'revert', true );
			setTimeout( function() {
				ui.draggable.draggable( 'option', 'revert', false );
				if(used_times<exist_times){
					setTimeout( function() {
						$('#'+droppedLetter).css({'visibility':'visible'});
					},300);
					$('#'+droppedLetter).attr({'used':used_times});
				}
				else{
					$('#'+droppedLetter).attr({'used':used_times});
				}
			}, 100 );
			if(true_choice == nb_words){
				//$('#rand_word').css({'display':'none'})
				$('#rand_word').prepend('<div id="fb_div"><div class="fb_div">'+fb_text+'</div></div>');
			}
		} else {
			if(navigator.userAgent.indexOf('MSIE 9.0')==-1)setTimeout('playsound("snd_false.mp3")',100);
			ui.draggable.draggable( 'option', 'revert', true );
			setTimeout( function() {
				ui.draggable.draggable( 'option', 'revert', false );
			}, 100 );
		}
	}
});
$('#random_word_table').css({'height':$('#random_word_table').height()});
function randOrd(){
	return (Math.round(Math.random())-0.25);
}