var Old_Top, Old_ID ;
(function ($) {
    // Detect touch support
    $.support.touch = 'ontouchend' in document;
    // Ignore browsers without touch support
    if (!$.support.touch) {
    return;
    }
    var mouseProto = $.ui.mouse.prototype,
        _mouseInit = mouseProto._mouseInit,
        touchHandled;

    function simulateMouseEvent (event, simulatedType) { //use this function to simulate mouse event
    // Ignore multi-touch events
        if (event.originalEvent.touches.length > 1) {
        return;
        }
    event.preventDefault(); //use this to prevent scrolling during ui use

    var touch = event.originalEvent.changedTouches[0],
        simulatedEvent = document.createEvent('MouseEvents');
    // Initialize the simulated mouse event using the touch event's coordinates
    simulatedEvent.initMouseEvent(
        simulatedType,    // type
        true,             // bubbles                    
        true,             // cancelable                 
        window,           // view                       
        1,                // detail                     
        touch.screenX,    // screenX                    
        touch.screenY,    // screenY                    
        touch.clientX,    // clientX                    
        touch.clientY,    // clientY                    
        false,            // ctrlKey                    
        false,            // altKey                     
        false,            // shiftKey                   
        false,            // metaKey                    
        0,                // button                     
        null              // relatedTarget              
        );

    // Dispatch the simulated event to the target element
    event.target.dispatchEvent(simulatedEvent);
    }
    mouseProto._touchStart = function (event) {
    var self = this;
    // Ignore the event if another widget is already being handled
    if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
        return;
        }
    // Set the flag to prevent other widgets from inheriting the touch event
    touchHandled = true;
    // Track movement to determine if interaction was a click
    self._touchMoved = false;
    // Simulate the mouseover event
    simulateMouseEvent(event, 'mouseover');
    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');
    // Simulate the mousedown event
    simulateMouseEvent(event, 'mousedown');
    };

    mouseProto._touchMove = function (event) {
    // Ignore event if not handled
    if (!touchHandled) {
        return;
        }
    // Interaction was not a click
    this._touchMoved = true;
    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');
    };
    mouseProto._touchEnd = function (event) {
    // Ignore event if not handled
    if (!touchHandled) {
        return;
    }
    // Simulate the mouseup event
    simulateMouseEvent(event, 'mouseup');
    // Simulate the mouseout event
    simulateMouseEvent(event, 'mouseout');
    // If the touch interaction did not move, it should trigger a click
    if (!this._touchMoved) {
      // Simulate the click event
      simulateMouseEvent(event, 'click');
    }
    // Unset the flag to allow other widgets to inherit the touch event
    touchHandled = false;
    };
    mouseProto._mouseInit = function () {
    var self = this;
    // Delegate the touch handlers to the widget's element
    self.element
        .on('touchstart', $.proxy(self, '_touchStart'))
        .on('touchmove', $.proxy(self, '_touchMove'))
        .on('touchend', $.proxy(self, '_touchEnd'));

    // Call the original $.ui.mouse init method
    _mouseInit.call(self);
    };
})(jQuery);



$(function() {
		var tops_ = new Array(), tops_2 = new Array(), tops_id = new Array(), id_= new Array();
	var The_Left;
	
	var Drag_Id;
	if(Text_Size[1]=='large') var txt_s1 = 'line-height:68px; font-size:32px;;direction:'+MyDir;
	if(Text_Size[1]=='small') var txt_s1 = 'line-height:normal; font-size:20px;direction:'+MyDir;
	if(Text_Size[0]=='large') var txt_s2 = 'line-height:68px; font-size:32px;direction:'+MyDir;
	if(Text_Size[0]=='small') var txt_s2 = 'line-height:normal; font-size:19px; ;direction:'+MyDir
		
	var correctCards = 0;
	var maxLetras    = 10; // 0 = todas
	$( init );
	function init() {

	  $("#cardPile, #cardSlots").empty();

	  correctCards = 0;
	  var imagens = new Array();
	  for(var a=0;a<images_.length;a++)
		  imagens[a] = a
	  function randOrd() { return Math.random() - .5 }
  	  imagens.sort( randOrd );	 
	  var sort_img = images_, sort_txt = txt;;
	  
  	 // sort_txt.sort( randOrd );	 
	//  alert(sort_img+' of '+sort_txt)
  	if ( !maxLetras > 0 ) {
 		maxLetras = imagens.length;
 		alert(maxLetras);
    }

	
	var Title_;
	 for ( var i=0; i < imagens.length; i++ ) {

	  	primeiraLetra = imagens[i]
		if(Match_Type==1){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 303px; position:absolute;right:19px;  top:'+((82*i)+5)+'px; height:72px;"><div class="component_base item" unselectable="on" style="width: 303px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="303" height="72" focusable="false"><path style="background:orange" class="shadow" d="M 18 6.2 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 "></path><path class="shadow grip" d="M 18 6.2 l 0 60.6 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="outline" d="M 18 4.7 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="fill" d="M 19 4.7 q 0 -3.7 3.7 -3.7 l 275.6 0 q 3.7 0 3.7 3.7 l 0 60.6 q 0 3.7 -3.7 3.7 l -275.6 0 q -3.7 0 -3.7 -3.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3"></path></svg></div><div style="position: absolute; overflow: hidden; left: 22px; width: 271px; height: 72px; top: 0px;"><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_img[imagens[i]]+'" /><div class="zoom" style="display: none;"></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((82*i)+5)+'px; position:absolute; width: 285px; height: 72px;"><div class="component_base item" unselectable="on" style="width: 285px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="285" height="72" focusable="false"><path class="shadow" d="M 0 6.2 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7z"></path><path class="outline" d="M 0 4.7 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7"></path><path class="fill" d="M 1 4.7 l 0 60.6 q 0 3.7 3.7 3.7 l 275.6 0 q 3.7 0 3.7 -3.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3 q 0 -3.7 -3.7 -3.7 l -275.6 0 q -3.7 0 -3.7 3.7"></path></svg><div style="width: 100%;height: 72px; z-index:999999; margin-top:-72px;display:block; "><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_txt[i]+'" /><div class="zoom" style="display: none;"></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		if(Match_Type==2){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 303px; position:absolute;right:19px;  top:'+((82*i)+5)+'px; height:72px;"><div class="component_base item" unselectable="on" style="width: 303px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="303" height="72" focusable="false"><path style="background:orange" class="shadow" d="M 18 6.2 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 "></path><path class="shadow grip" d="M 18 6.2 l 0 60.6 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="outline" d="M 18 4.7 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="fill" d="M 19 4.7 q 0 -3.7 3.7 -3.7 l 275.6 0 q 3.7 0 3.7 3.7 l 0 60.6 q 0 3.7 -3.7 3.7 l -275.6 0 q -3.7 0 -3.7 -3.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3"></path></svg></div><div style="position: absolute; overflow: hidden; left: 22px; width: 271px; height: 72px; top: 0px;"><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_img[imagens[i]]+'" /><div class="zoom" style="display: none;"></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((82*i)+5)+'px; position:absolute; width: 285px; height: 72px;"><div class="component_base item" unselectable="on" style="width: 285px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="285" height="72" focusable="false"><path class="shadow" d="M 0 6.2 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7z"></path><path class="outline" d="M 0 4.7 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7"></path><path class="fill" d="M 1 4.7 l 0 60.6 q 0 3.7 3.7 3.7 l 275.6 0 q 3.7 0 3.7 -3.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3 q 0 -3.7 -3.7 -3.7 l -275.6 0 q -3.7 0 -3.7 3.7"></path></svg><div style="width: 100%;height: 72px; z-index:999999; margin-top:-72px;display:block; "><div class="text" style="position: relative; width: 265px;float:left; height: 67px; top: 0px; margin:0 auto;'+txt_s2+' "><p style=" width:100%">'+sort_txt[i]+'</p></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		if(Match_Type==3){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 303px; position:absolute;right:19px;  top:'+((82*i)+5)+'px; height:72px;"><div class="component_base item" unselectable="on" style="width: 303px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="303" height="72" focusable="false"><path style="background:orange" class="shadow" d="M 18 6.2 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 "></path><path class="shadow grip" d="M 18 6.2 l 0 60.6 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="outline" d="M 18 4.7 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="fill" d="M 19 4.7 q 0 -3.7 3.7 -3.7 l 275.6 0 q 3.7 0 3.7 3.7 l 0 60.6 q 0 3.7 -3.7 3.7 l -275.6 0 q -3.7 0 -3.7 -3.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3"></path></svg></div><div style="position: absolute; overflow: hidden; left: 22px; width: 271px; height: 72px; top: -1px;"><div class="image" style="position: relative; width: 265px; ;float:left; height: 67px; top: 0px; margin:0 auto;'+txt_s1+' ">'+sort_img[imagens[i]]+'<div class="zoom" style="display: none;"></div></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((82*i)+5)+'px; position:absolute; width: 285px; height: 72px;"><div class="component_base item" unselectable="on" style="width: 285px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="285" height="72" focusable="false"><path class="shadow" d="M 0 6.2 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7z"></path><path class="outline" d="M 0 4.7 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7"></path><path class="fill" d="M 1 4.7 l 0 60.6 q 0 3.7 3.7 3.7 l 275.6 0 q 3.7 0 3.7 -3.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3 q 0 -3.7 -3.7 -3.7 l -275.6 0 q -3.7 0 -3.7 3.7"></path></svg><div style="width: 100%;height: 72px; z-index:999999; margin-top:-72px;display:block; "><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_txt[i]+'" /><div class="zoom" style="display: none;"></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}				
		if(Match_Type==4){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 303px; position:absolute;right:19px;  top:'+((82*i)+5)+'px; height:72px;"><div class="component_base item" unselectable="on" style="width: 303px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="303" height="72" focusable="false"><path style="background:orange" class="shadow" d="M 18 6.2 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 "></path><path class="shadow grip" d="M 18 6.2 l 0 60.6 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="outline" d="M 18 4.7 q 0 -4.7 4.7 -4.7 l 275.6 0 q 4.7 0 4.7 4.7 l 0 60.6 q 0 4.7 -4.7 4.7 l -275.6 0 q -4.7 0 -4.7 -4.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3"></path>  <path class="fill" d="M 19 4.7 q 0 -3.7 3.7 -3.7 l 275.6 0 q 3.7 0 3.7 3.7 l 0 60.6 q 0 3.7 -3.7 3.7 l -275.6 0 q -3.7 0 -3.7 -3.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3"></path></svg></div><div style="position: absolute; overflow: hidden; left: 22px; width: 271px; height: 72px; top: -1px;"><div class="image" style="position: relative; width: 265px; height: 67px; top: 0px; margin:0 auto;'+txt_s1+' ">'+sort_img[imagens[i]]+'</div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((82*i)+5)+'px; position:absolute; width: 285px; height: 72px;"><div class="component_base item" unselectable="on" style="width: 285px; height: 72px;"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="285" height="72" focusable="false"><path class="shadow" d="M 0 6.2 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7z"></path><path class="outline" d="M 0 4.7 l 0 60.6 q 0 4.7 4.7 4.7 l 275.6 0 q 4.7 0 4.7 -4.7 l 0 -23.3 q 0 -2 -2 -2 l -5.15 0 q -1.7 5 -4.85 5 q -6 0 -6 -10 q 0 -10 6 -10 q 3.15 0 4.85 5 l 5.15 0 q 2 0 2 -2 l 0 -23.3 q 0 -4.7 -4.7 -4.7 l -275.6 0 q -4.7 0 -4.7 4.7"></path><path class="fill" d="M 1 4.7 l 0 60.6 q 0 3.7 3.7 3.7 l 275.6 0 q 3.7 0 3.7 -3.7 l 0 -22.3 q 0 -2 -2 -2 l -3.15 0 q -2.05 5 -5.85 5 q -7 0 -7 -11 q 0 -11 7 -11 q 3.8 0 5.85 5 l 3.15 0 q 2 0 2 -2 l 0 -22.3 q 0 -3.7 -3.7 -3.7 l -275.6 0 q -3.7 0 -3.7 3.7"></path></svg><div style="width: 100%;height: 72px; z-index:999999; margin-top:-72px;display:block; "><div class="text" style="position: relative; width: 265px; float:left; height: 67px; top: 0px; margin:0 auto;'+txt_s2+' "><p style=" width:100%">'+sort_txt[i]+'</p></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		


	  }

	//$("#cardPile > div").shuffle();
}

var topps = new Array();
var id_id = new Array();

var topps1 = new Array();
var id_id1 = new Array();

function handleCardDrop( event, ui ) {
var slotNumber = $(this).data( 'letra' );
var cardNumber = ui.draggable.data( 'letra' );
  
if(slotNumber==cardNumber){
	var Drop_Id = $(this).attr('id');
	var Drop_Top = $(this).css('top');
	
	var Drag_Id = $('.ui-draggable-dragging').attr('id');
	var Drag_Top = $(this).css('top');	

	var get_top_ind = $.inArray(Drag_Id,id_);


	$('#'+Drag_Id).css('top',Drop_Top);
	var sub_id = $('.'+Drop_Id).attr('id');	
	$('#'+sub_id).css('top',tops_[get_top_ind]);
	
	var tempo = 'temp';

	// dragg
	/*************************/	
	var New_Id_1 = $('#'+Drag_Id).attr('id').split('DragMe')[1];
	var New_Id_2 = $('.'+Drop_Id).attr('id').split('DragMe')[1];

	var new_class = 'my_item'+New_Id_2;
	var new_id = 'DragMe'+New_Id_2;
		
	$('.my_item'+New_Id_1).removeClass('my_item'+New_Id_1).addClass(tempo)
	$('#'+Drag_Id).removeAttr('id').attr('id',tempo)	
	
	/*************************/
	
	// Other
	/*************************/
	$('.my_item'+New_Id_2).removeClass('my_item'+New_Id_2).addClass('my_item'+New_Id_1)
	$('.my_item'+New_Id_1).removeAttr('id').attr('id','DragMe'+New_Id_1)
	/*************************/	
	$('.'+tempo).removeClass('my_item'+New_Id_1+' '+tempo).addClass(new_class)
	$('#'+tempo).removeAttr('id').attr('id',new_id)	

	

	var SOUND = soundManager.createSound({url:CurDir+'snd_true.mp3',id:'true'});
	SOUND.play();	  
		
    ui.draggable.addClass( 'correct' );
    $(this).droppable( 'disable' ).css('margin-left','19px');

    ui.draggable.draggable( 'disable' ).css('left','300px');
    ui.draggable.draggable( 'option', 'revert', false );

	setTimeout(function(){
		for(var c=0;c<txt.length;c++){
			tops_[c] =  $('#DragMe'+c).css('top')
			id_[c]   =  $('#DragMe'+c).attr('id');
		}
	},500)
}
else{
	var SOUND = soundManager.createSound({url:CurDir+'snd_false.mp3',id:'false'});
	SOUND.play();		  
}
  

  if ( correctCards == maxLetras ) {/*
  		$(".success").toggleClass('isHidden');
  		$(".reset").click(function(event) {
  			$( init );
  			$(".success").toggleClass('isHidden');
  		});
  */}

}

 
   $.fn.shuffle = function() {

  var elements = this.get()
  var copy = [].concat(elements)
  var shuffled = []
  var placeholders = []

  // Shuffle the element array
  while (copy.length) {
    var rand = Math.floor(Math.random() * copy.length)
    var element = copy.splice(rand,1)[0]
    shuffled.push(element)
  }

  // replace all elements with a plcaceholder
  for (var i = 0; i < elements.length; i++) {
    var placeholder = document.createTextNode('')
    findAndReplace(elements[i], placeholder)
    placeholders.push(placeholder)
  }

  // replace the placeholders with the shuffled elements
  for (var i = 0; i < elements.length; i++) {
    findAndReplace(placeholders[i], shuffled[i])
  }

  return $(shuffled)

}

function findAndReplace(find, replace) {
  find.parentNode.replaceChild(replace, find)
}
setTimeout(function(){
	$('.ui-droppable').each(function(){
		if(!$(this).hasClass('component_container item connected'))
			$(this).remove();

	});
	$('.item.ui-draggable').each(function(i) {
		tops_[i] =  $(this).css('top')
		id_[i] = $(this).attr('id');
	//	$('body').append(tops_[i]+' of : '+id_[i]+'<br/>')
	});	
},10)



})

