var Old_Top, Old_ID ;
(function ($) {
    // Detect touch support
    $.support.touch = 'ontouchend' in document;
    // Ignore browsers without touch support
    if (!$.support.touch) {
    return;
    }
    var mouseProto = $.ui.mouse.prototype,
        _mouseInit = mouseProto._mouseInit,
        touchHandled;

    function simulateMouseEvent (event, simulatedType) { //use this function to simulate mouse event
    // Ignore multi-touch events
        if (event.originalEvent.touches.length > 1) {
        return;
        }
    event.preventDefault(); //use this to prevent scrolling during ui use

    var touch = event.originalEvent.changedTouches[0],
        simulatedEvent = document.createEvent('MouseEvents');
    // Initialize the simulated mouse event using the touch event's coordinates
    simulatedEvent.initMouseEvent(
        simulatedType,    // type
        true,             // bubbles                    
        true,             // cancelable                 
        window,           // view                       
        1,                // detail                     
        touch.screenX,    // screenX                    
        touch.screenY,    // screenY                    
        touch.clientX,    // clientX                    
        touch.clientY,    // clientY                    
        false,            // ctrlKey                    
        false,            // altKey                     
        false,            // shiftKey                   
        false,            // metaKey                    
        0,                // button                     
        null              // relatedTarget              
        );

    // Dispatch the simulated event to the target element
    event.target.dispatchEvent(simulatedEvent);
    }
    mouseProto._touchStart = function (event) {
    var self = this;
    // Ignore the event if another widget is already being handled
    if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
        return;
        }
    // Set the flag to prevent other widgets from inheriting the touch event
    touchHandled = true;
    // Track movement to determine if interaction was a click
    self._touchMoved = false;
    // Simulate the mouseover event
    simulateMouseEvent(event, 'mouseover');
    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');
    // Simulate the mousedown event
    simulateMouseEvent(event, 'mousedown');
    };

    mouseProto._touchMove = function (event) {
    // Ignore event if not handled
    if (!touchHandled) {
        return;
        }
    // Interaction was not a click
    this._touchMoved = true;
    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');
    };
    mouseProto._touchEnd = function (event) {
    // Ignore event if not handled
    if (!touchHandled) {
        return;
    }
    // Simulate the mouseup event
    simulateMouseEvent(event, 'mouseup');
    // Simulate the mouseout event
    simulateMouseEvent(event, 'mouseout');
    // If the touch interaction did not move, it should trigger a click
    if (!this._touchMoved) {
      // Simulate the click event
      simulateMouseEvent(event, 'click');
    }
    // Unset the flag to allow other widgets to inherit the touch event
    touchHandled = false;
    };
    mouseProto._mouseInit = function () {
    var self = this;
    // Delegate the touch handlers to the widget's element
    self.element
        .on('touchstart', $.proxy(self, '_touchStart'))
        .on('touchmove', $.proxy(self, '_touchMove'))
        .on('touchend', $.proxy(self, '_touchEnd'));

    // Call the original $.ui.mouse init method
    _mouseInit.call(self);
    };
})(jQuery);



$(function() {
		var tops_ = new Array(), tops_2 = new Array(), tops_id = new Array(), id_= new Array();
	var The_Left;
	
	var Drag_Id;
	if(Text_Size[1]=='large') var txt_s1 = 'line-height:2.5vw; font-size:2.5vw;;direction:'+MyDir;
	if(Text_Size[1]=='small') var txt_s1 = 'line-height:normal; font-size:20px;direction:'+MyDir;
	if(Text_Size[0]=='large') var txt_s2 = 'line-height:2.5vw;; font-size:2.5vw;;direction:'+MyDir;
	if(Text_Size[0]=='small') var txt_s2 = 'line-height:normal; font-size:19px; ;direction:'+MyDir
		
	var correctCards = 0;
	var maxLetras    = 10; // 0 = todas
	$( init );
	function init() {

	  $("#cardPile, #cardSlots").empty();

	  correctCards = 0;
	  var imagens = new Array();
	  for(var a=0;a<images_.length;a++)
		  imagens[a] = a
	  function randOrd() { return Math.random() - .5 }
  	  imagens.sort( randOrd );	 
	  var sort_img = images_, sort_txt = txt;;
	  
  	 // sort_txt.sort( randOrd );	 
	//  alert(sort_img+' of '+sort_txt)
  	if ( !maxLetras > 0 ) {
 		maxLetras = imagens.length;
 		alert(maxLetras);
    }

	
	var Title_;
	 for ( var i=0; i < imagens.length; i++ ) {

	  	primeiraLetra = imagens[i]
		if(Match_Type==1){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 343px;position:absolute;right:19px;  top:'+((122*i)+5)+'px; height:112px;"><div class="component_base item" unselectable="on" style="width: 343px; height: 112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="343px"   height="111.5px"   viewBox="0 0 345 112"   id="svg3349"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="right.svg">  <defs     id="defs3351" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="0"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1" />  <metadata     id="metadata3354">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />        <dc:title></dc:title>      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m 21.733381,9.995023 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.502097 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937"       id="path4" />    <path       inkscape:connector-curvature="0"       class="shadow grip"       d="m 21.733381,9.995023 0,94.502097 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153841 0,-17.153853 7.9240925,-17.153853 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.775521"       id="path6" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m 21.733381,7.6558629 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.5020971 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937 l 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153842 0,-17.153852 7.9240925,-17.153852 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.7755211"       id="path8" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 22.865394,7.6558629 q 0,-5.7699328 4.188449,-5.7699328 l 311.982837,0 q 4.18845,0 4.18845,5.7699328 l 0,94.5020971 q 0,5.76993 -4.18845,5.76993 l -311.982837,0 q -4.188449,0 -4.188449,-5.76993 l 0,-36.334964 q 0,-3.11888 -2.264026,-3.11888 l -5.829868,0 q -1.924423,7.7972 -5.4902645,7.7972 -6.7920793,0 -6.7920793,-15.594401 0,-15.594412 6.7920793,-15.594412 3.5658415,0 5.4902645,7.797201 l 5.829868,0 q 2.264026,0 2.264026,-3.11888 l 0,-36.3349611"       id="path10" />  </g></svg></div><div style="position: absolute; overflow: hidden; left: 45px; width: 271px; height: 112px; top: 0px;"><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_img[imagens[i]]+'" /><div class="zoom" style="display: none;"></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((122*i)+5)+'px; position:absolute; width: 325px; height: 112px; "><div class="component_base item" unselectable="on" style="width: 325px; height:112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="325px"   height="111.5"   viewBox="0 0 327 112"   id="svg3353"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="left.svg">  <defs     id="defs3355" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="5"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1"     showguides="false" />  <metadata     id="metadata3358">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m -0.5000014,11.566452 0,94.502098 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334963 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797203 -5.5307,7.797203 -6.84211,0 -6.84211,-15.594407 0,-15.594405 6.84211,-15.594405 3.5921,0 5.5307,7.797203 l 5.87281,0 q 2.2807,0 2.2807,-3.118882 l 0,-36.334966 q 0,-7.3293711 -5.35965,-7.3293711 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.3293711 z"       id="path4" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m -0.5000014,9.227291 0,94.502099 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334964 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797204 -5.5307,7.797204 -6.84211,0 -6.84211,-15.594407 0,-15.594406 6.84211,-15.594406 3.5921,0 5.5307,7.797202 l 5.87281,0 q 2.2807,0 2.2807,-3.118881 l 0,-36.334966 q 0,-7.329371 -5.35965,-7.329371 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.329371"       id="path6" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 0.6403495,9.227291 0,94.502099 q 0,5.76993 4.2192982,5.76993 l 314.2807023,0 q 4.2193,0 4.2193,-5.76993 l 0,-34.775523 q 0,-3.118881 -2.2807,-3.118881 l -3.59211,0 q -2.33772,7.797203 -6.67105,7.797203 -7.98246,0 -7.98246,-17.153847 0,-17.153848 7.98246,-17.153848 4.33333,0 6.67105,7.797204 l 3.59211,0 q 2.2807,0 2.2807,-3.118881 l 0,-34.775526 q 0,-5.7699304 -4.2193,-5.7699304 l -314.2807023,0 q -4.2192982,0 -4.2192982,5.7699304"       id="path8" />  </g></svg><div style="width: 100%;height: 112px; z-index:999999; margin-top:-112px;display:block; "><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_txt[i]+'" /><div class="zoom" style="display: none;"></div></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		if(Match_Type==2){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 343px;position:absolute;right:19px;  top:'+((122*i)+5)+'px; height:112px;"><div class="component_base item" unselectable="on" style="width: 343px; height: 112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="343px"   height="111.5px"   viewBox="0 0 345 112"   id="svg3349"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="right.svg">  <defs     id="defs3351" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="0"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1" />  <metadata     id="metadata3354">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />        <dc:title></dc:title>      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m 21.733381,9.995023 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.502097 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937"       id="path4" />    <path       inkscape:connector-curvature="0"       class="shadow grip"       d="m 21.733381,9.995023 0,94.502097 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153841 0,-17.153853 7.9240925,-17.153853 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.775521"       id="path6" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m 21.733381,7.6558629 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.5020971 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937 l 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153842 0,-17.153852 7.9240925,-17.153852 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.7755211"       id="path8" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 22.865394,7.6558629 q 0,-5.7699328 4.188449,-5.7699328 l 311.982837,0 q 4.18845,0 4.18845,5.7699328 l 0,94.5020971 q 0,5.76993 -4.18845,5.76993 l -311.982837,0 q -4.188449,0 -4.188449,-5.76993 l 0,-36.334964 q 0,-3.11888 -2.264026,-3.11888 l -5.829868,0 q -1.924423,7.7972 -5.4902645,7.7972 -6.7920793,0 -6.7920793,-15.594401 0,-15.594412 6.7920793,-15.594412 3.5658415,0 5.4902645,7.797201 l 5.829868,0 q 2.264026,0 2.264026,-3.11888 l 0,-36.3349611"       id="path10" />  </g></svg></div><div style="position: absolute; overflow: hidden; left: 45px; width: 271px; height: 112px; top: 0px;"><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_img[imagens[i]]+'" /><div class="zoom" style="display: none;"></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((122*i)+5)+'px; position:absolute; width: 325px; height: 112px; "><div class="component_base item" unselectable="on" style="width: 325px; height:112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="325px"   height="111.5"   viewBox="0 0 327 112"   id="svg3353"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="left.svg">  <defs     id="defs3355" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="5"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1"     showguides="false" />  <metadata     id="metadata3358">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m -0.5000014,11.566452 0,94.502098 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334963 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797203 -5.5307,7.797203 -6.84211,0 -6.84211,-15.594407 0,-15.594405 6.84211,-15.594405 3.5921,0 5.5307,7.797203 l 5.87281,0 q 2.2807,0 2.2807,-3.118882 l 0,-36.334966 q 0,-7.3293711 -5.35965,-7.3293711 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.3293711 z"       id="path4" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m -0.5000014,9.227291 0,94.502099 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334964 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797204 -5.5307,7.797204 -6.84211,0 -6.84211,-15.594407 0,-15.594406 6.84211,-15.594406 3.5921,0 5.5307,7.797202 l 5.87281,0 q 2.2807,0 2.2807,-3.118881 l 0,-36.334966 q 0,-7.329371 -5.35965,-7.329371 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.329371"       id="path6" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 0.6403495,9.227291 0,94.502099 q 0,5.76993 4.2192982,5.76993 l 314.2807023,0 q 4.2193,0 4.2193,-5.76993 l 0,-34.775523 q 0,-3.118881 -2.2807,-3.118881 l -3.59211,0 q -2.33772,7.797203 -6.67105,7.797203 -7.98246,0 -7.98246,-17.153847 0,-17.153848 7.98246,-17.153848 4.33333,0 6.67105,7.797204 l 3.59211,0 q 2.2807,0 2.2807,-3.118881 l 0,-34.775526 q 0,-5.7699304 -4.2193,-5.7699304 l -314.2807023,0 q -4.2192982,0 -4.2192982,5.7699304"       id="path8" />  </g></svg><div style="width: 100%;height: 112px; z-index:999999; margin-top:-112px;display:block; "><div class="text" style="position: relative; width: 295px;float:left; position: absolute; top: 40%;display: table-cell; vertical-align: middle; font-size:2.5vw!important;  "><p style=" width:100%">'+sort_txt[i]+'</p></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		if(Match_Type==3){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 343px;position:absolute;right:19px;  top:'+((122*i)+5)+'px; height:112px;"><div class="component_base item" unselectable="on" style="width: 343px; height: 112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="343px"   height="111.5px"   viewBox="0 0 345 112"   id="svg3349"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="right.svg">  <defs     id="defs3351" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="0"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1" />  <metadata     id="metadata3354">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />        <dc:title></dc:title>      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m 21.733381,9.995023 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.502097 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937"       id="path4" />    <path       inkscape:connector-curvature="0"       class="shadow grip"       d="m 21.733381,9.995023 0,94.502097 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153841 0,-17.153853 7.9240925,-17.153853 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.775521"       id="path6" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m 21.733381,7.6558629 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.5020971 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937 l 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153842 0,-17.153852 7.9240925,-17.153852 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.7755211"       id="path8" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 22.865394,7.6558629 q 0,-5.7699328 4.188449,-5.7699328 l 311.982837,0 q 4.18845,0 4.18845,5.7699328 l 0,94.5020971 q 0,5.76993 -4.18845,5.76993 l -311.982837,0 q -4.188449,0 -4.188449,-5.76993 l 0,-36.334964 q 0,-3.11888 -2.264026,-3.11888 l -5.829868,0 q -1.924423,7.7972 -5.4902645,7.7972 -6.7920793,0 -6.7920793,-15.594401 0,-15.594412 6.7920793,-15.594412 3.5658415,0 5.4902645,7.797201 l 5.829868,0 q 2.264026,0 2.264026,-3.11888 l 0,-36.3349611"       id="path10" />  </g></svg></div><div style="position: absolute; overflow: hidden; left: 45px; width: 271px; height: 112px; top: 0px;"><div class="image" style="position: relative; width: 265px; ;float:left; height: 67px; top: 0px; margin:0 auto;'+txt_s1+' ">'+sort_img[imagens[i]]+'<div class="zoom" style="display: none;"></div></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((122*i)+5)+'px; position:absolute; width: 325px; height: 112px; "><div class="component_base item" unselectable="on" style="width: 325px; height:112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="325px"   height="111.5"   viewBox="0 0 327 112"   id="svg3353"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="left.svg">  <defs     id="defs3355" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="5"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1"     showguides="false" />  <metadata     id="metadata3358">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m -0.5000014,11.566452 0,94.502098 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334963 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797203 -5.5307,7.797203 -6.84211,0 -6.84211,-15.594407 0,-15.594405 6.84211,-15.594405 3.5921,0 5.5307,7.797203 l 5.87281,0 q 2.2807,0 2.2807,-3.118882 l 0,-36.334966 q 0,-7.3293711 -5.35965,-7.3293711 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.3293711 z"       id="path4" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m -0.5000014,9.227291 0,94.502099 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334964 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797204 -5.5307,7.797204 -6.84211,0 -6.84211,-15.594407 0,-15.594406 6.84211,-15.594406 3.5921,0 5.5307,7.797202 l 5.87281,0 q 2.2807,0 2.2807,-3.118881 l 0,-36.334966 q 0,-7.329371 -5.35965,-7.329371 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.329371"       id="path6" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 0.6403495,9.227291 0,94.502099 q 0,5.76993 4.2192982,5.76993 l 314.2807023,0 q 4.2193,0 4.2193,-5.76993 l 0,-34.775523 q 0,-3.118881 -2.2807,-3.118881 l -3.59211,0 q -2.33772,7.797203 -6.67105,7.797203 -7.98246,0 -7.98246,-17.153847 0,-17.153848 7.98246,-17.153848 4.33333,0 6.67105,7.797204 l 3.59211,0 q 2.2807,0 2.2807,-3.118881 l 0,-34.775526 q 0,-5.7699304 -4.2193,-5.7699304 l -314.2807023,0 q -4.2192982,0 -4.2192982,5.7699304"       id="path8" />  </g></svg><div style="width: 100%;height: 112px; z-index:999999; margin-top:-112px;display:block; "><img class="image" style="position: relative;   width:auto; max-width:93%; height:93%; " src="'+sort_txt[i]+'" /><div class="zoom" style="display: none;"></div></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}				
		if(Match_Type==4){

			$('<div class="component_container item my_item'+i+'" id="DragMe'+i+'" style=" width: 343px;position:absolute;right:19px;  top:'+((122*i)+5)+'px; height:112px;"><div class="component_base item" unselectable="on" style="width: 343px; height: 112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="343px"   height="111.5px"   viewBox="0 0 345 112"   id="svg3349"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="right.svg">  <defs     id="defs3351" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="0"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1" />  <metadata     id="metadata3354">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />        <dc:title></dc:title>      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m 21.733381,9.995023 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.502097 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937"       id="path4" />    <path       inkscape:connector-curvature="0"       class="shadow grip"       d="m 21.733381,9.995023 0,94.502097 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153841 0,-17.153853 7.9240925,-17.153853 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.775521"       id="path6" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m 21.733381,7.6558629 q 0,-7.3293729 5.320462,-7.3293729 l 311.982837,0 q 5.32046,0 5.32046,7.3293729 l 0,94.5020971 q 0,7.32937 -5.32046,7.32937 l -311.982837,0 q -5.320462,0 -5.320462,-7.32937 l 0,-34.775524 q 0,-3.11888 -2.264027,-3.11888 l -3.565841,0 q -2.320627,7.797201 -6.6222775,7.797201 -7.9240925,0 -7.9240925,-17.153842 0,-17.153852 7.9240925,-17.153852 4.3016505,0 6.6222775,7.797201 l 3.565841,0 q 2.264027,0 2.264027,-3.11888 l 0,-34.7755211"       id="path8" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 22.865394,7.6558629 q 0,-5.7699328 4.188449,-5.7699328 l 311.982837,0 q 4.18845,0 4.18845,5.7699328 l 0,94.5020971 q 0,5.76993 -4.18845,5.76993 l -311.982837,0 q -4.188449,0 -4.188449,-5.76993 l 0,-36.334964 q 0,-3.11888 -2.264026,-3.11888 l -5.829868,0 q -1.924423,7.7972 -5.4902645,7.7972 -6.7920793,0 -6.7920793,-15.594401 0,-15.594412 6.7920793,-15.594412 3.5658415,0 5.4902645,7.797201 l 5.829868,0 q 2.264026,0 2.264026,-3.11888 l 0,-36.3349611"       id="path10" />  </g></svg></div><div style="position: absolute; overflow: hidden; left: 45px; width: 271px; height: 112px; top: 0px;"><div class="image" style="position: relative; width: 265px; ;float:left; height: 67px; top: 0px; margin:0 auto;'+txt_s1+' ">'+sort_img[imagens[i]]+'<div class="zoom" style="display: none;"></div></div></div></div>').data( 'letra', imagens[i] ).appendTo( '#cardPile' ).draggable( {
				containment: '#content',
				stack: '#cardPile div',
				cursor: 'move',
				revert: true,
				drag: function( event, ui ){
					//Drag_Id = $(this).attr('id');
				var drag_id = $('.ui-draggable-dragging').attr('id');
				Old_Top = parseInt($('.ui-draggable-dragging').css('top').split('px')[0])+5;					
									
				}			
			} );
			/********** left ***********/
			
	    $('<div class="component_container item connected " id="my_item'+i+'" style="left: 19px;top:'+((122*i)+5)+'px; position:absolute; width: 325px; height: 112px; "><div class="component_base item" unselectable="on" style="width: 325px; height:112px;"><?xml version="1.0" encoding="UTF-8" standalone="no"?><!-- Created with Inkscape (http://www.inkscape.org/) --><svg   xmlns:dc="http://purl.org/dc/elements/1.1/"   xmlns:cc="http://creativecommons.org/ns#"   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"   xmlns:svg="http://www.w3.org/2000/svg"   xmlns="http://www.w3.org/2000/svg"   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"   width="325px"   height="111.5"   viewBox="0 0 327 112"   id="svg3353"   version="1.1"   inkscape:version="0.91 r13725"   sodipodi:docname="left.svg">  <defs     id="defs3355" />  <sodipodi:namedview     id="base"     pagecolor="#ffffff"     bordercolor="#666666"     borderopacity="1.0"     inkscape:pageopacity="0.0"     inkscape:pageshadow="2"     inkscape:zoom="1"     inkscape:cx="0"     inkscape:cy="5"     inkscape:document-units="px"     inkscape:current-layer="layer1"     showgrid="false"     inkscape:window-width="1366"     inkscape:window-height="706"     inkscape:window-x="-8"     inkscape:window-y="-8"     inkscape:window-maximized="1"     showguides="false" />  <metadata     id="metadata3358">    <rdf:RDF>      <cc:Work         rdf:about="">        <dc:format>image/svg+xml</dc:format>        <dc:type           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />      </cc:Work>    </rdf:RDF>  </metadata>  <g     inkscape:label="Layer 1"     inkscape:groupmode="layer"     id="layer1">    <path       inkscape:connector-curvature="0"       class="shadow"       d="m -0.5000014,11.566452 0,94.502098 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334963 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797203 -5.5307,7.797203 -6.84211,0 -6.84211,-15.594407 0,-15.594405 6.84211,-15.594405 3.5921,0 5.5307,7.797203 l 5.87281,0 q 2.2807,0 2.2807,-3.118882 l 0,-36.334966 q 0,-7.3293711 -5.35965,-7.3293711 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.3293711 z"       id="path4" />    <path       inkscape:connector-curvature="0"       class="outline"       d="m -0.5000014,9.227291 0,94.502099 q 0,7.32937 5.3596491,7.32937 l 314.2807023,0 q 5.35965,0 5.35965,-7.32937 l 0,-36.334964 q 0,-3.118881 -2.2807,-3.118881 l -5.87281,0 q -1.9386,7.797204 -5.5307,7.797204 -6.84211,0 -6.84211,-15.594407 0,-15.594406 6.84211,-15.594406 3.5921,0 5.5307,7.797202 l 5.87281,0 q 2.2807,0 2.2807,-3.118881 l 0,-36.334966 q 0,-7.329371 -5.35965,-7.329371 l -314.2807023,0 q -5.3596491,0 -5.3596491,7.329371"       id="path6" />    <path       inkscape:connector-curvature="0"       class="fill"       d="m 0.6403495,9.227291 0,94.502099 q 0,5.76993 4.2192982,5.76993 l 314.2807023,0 q 4.2193,0 4.2193,-5.76993 l 0,-34.775523 q 0,-3.118881 -2.2807,-3.118881 l -3.59211,0 q -2.33772,7.797203 -6.67105,7.797203 -7.98246,0 -7.98246,-17.153847 0,-17.153848 7.98246,-17.153848 4.33333,0 6.67105,7.797204 l 3.59211,0 q 2.2807,0 2.2807,-3.118881 l 0,-34.775526 q 0,-5.7699304 -4.2193,-5.7699304 l -314.2807023,0 q -4.2192982,0 -4.2192982,5.7699304"       id="path8" />  </g></svg><div style="width: 100%;height: 112px; z-index:999999; margin-top:-112px;display:block; "><div class="text" style="position: relative; width: 295px;float:left; position: absolute; top: 40%;display: table-cell; vertical-align: middle;;'+txt_s2+'  "><p style=" width:100%">'+sort_txt[i]+'</p></div></div></div></div><div>').data( 'letra', i ).appendTo( '#cardSlots' ).droppable( {
	        accept: '#cardPile div',
	        hoverClass: 'hovered',
	        drop: handleCardDrop
	    } );			
					
		}
		


	  }

	//$("#cardPile > div").shuffle();
}

var topps = new Array();
var id_id = new Array();

var topps1 = new Array();
var id_id1 = new Array();

function handleCardDrop( event, ui ) {
var slotNumber = $(this).data( 'letra' );
var cardNumber = ui.draggable.data( 'letra' );
  
if(slotNumber==cardNumber){
	var Drop_Id = $(this).attr('id');
	var Drop_Top = $(this).css('top');
	
	var Drag_Id = $('.ui-draggable-dragging').attr('id');
	var Drag_Top = $(this).css('top');	

	var get_top_ind = $.inArray(Drag_Id,id_);


	$('#'+Drag_Id).css('top',Drop_Top);
	var sub_id = $('.'+Drop_Id).attr('id');	
	$('#'+sub_id).css('top',tops_[get_top_ind]);
	
	var tempo = 'temp';

	// dragg
	/*************************/	
	var New_Id_1 = $('#'+Drag_Id).attr('id').split('DragMe')[1];
	var New_Id_2 = $('.'+Drop_Id).attr('id').split('DragMe')[1];

	var new_class = 'my_item'+New_Id_2;
	var new_id = 'DragMe'+New_Id_2;
		
	$('.my_item'+New_Id_1).removeClass('my_item'+New_Id_1).addClass(tempo)
	$('#'+Drag_Id).removeAttr('id').attr('id',tempo)	
	
	/*************************/
	
	// Other
	/*************************/
	$('.my_item'+New_Id_2).removeClass('my_item'+New_Id_2).addClass('my_item'+New_Id_1)
	$('.my_item'+New_Id_1).removeAttr('id').attr('id','DragMe'+New_Id_1)
	/*************************/	
	$('.'+tempo).removeClass('my_item'+New_Id_1+' '+tempo).addClass(new_class)
	$('#'+tempo).removeAttr('id').attr('id',new_id)	

	

	var SOUND = soundManager.createSound({url:CurDir+'snd_true.mp3',id:'true'});
	SOUND.play();	  
		
    ui.draggable.addClass( 'correct' );
    $(this).droppable( 'disable' ).css('margin-left','19px');

    ui.draggable.draggable( 'disable' ).css('left','333px');
    ui.draggable.draggable( 'option', 'revert', false );

	setTimeout(function(){
		for(var c=0;c<txt.length;c++){
			tops_[c] =  $('#DragMe'+c).css('top')
			id_[c]   =  $('#DragMe'+c).attr('id');
		}
	},500)
}
else{
	var SOUND = soundManager.createSound({url:CurDir+'snd_false.mp3',id:'false'});
	SOUND.play();		  
}
  

  if ( correctCards == maxLetras ) {/*
  		$(".success").toggleClass('isHidden');
  		$(".reset").click(function(event) {
  			$( init );
  			$(".success").toggleClass('isHidden');
  		});
  */}

}

 
   $.fn.shuffle = function() {

  var elements = this.get()
  var copy = [].concat(elements)
  var shuffled = []
  var placeholders = []

  // Shuffle the element array
  while (copy.length) {
    var rand = Math.floor(Math.random() * copy.length)
    var element = copy.splice(rand,1)[0]
    shuffled.push(element)
  }

  // replace all elements with a plcaceholder
  for (var i = 0; i < elements.length; i++) {
    var placeholder = document.createTextNode('')
    findAndReplace(elements[i], placeholder)
    placeholders.push(placeholder)
  }

  // replace the placeholders with the shuffled elements
  for (var i = 0; i < elements.length; i++) {
    findAndReplace(placeholders[i], shuffled[i])
  }

  return $(shuffled)

}

function findAndReplace(find, replace) {
  find.parentNode.replaceChild(replace, find)
}
setTimeout(function(){
	$('.ui-droppable').each(function(){
		if(!$(this).hasClass('component_container item connected'))
			$(this).remove();

	});
	$('.item.ui-draggable').each(function(i) {
		tops_[i] =  $(this).css('top')
		id_[i] = $(this).attr('id');
	//	$('body').append(tops_[i]+' of : '+id_[i]+'<br/>')
	});	
},10)



})

