


//////////// Languages
var langs =
[['Afrikaans',       ['af-ZA']],
 ['Bahasa Indonesia',['id-ID']],
 ['Bahasa Melayu',   ['ms-MY']],
 ['Català',          ['ca-ES']],
 ['Čeština',         ['cs-CZ']],
 ['Deutsch',         ['de-DE']],
 ['English',         ['en-AU', 'Australia'],
                     ['en-CA', 'Canada'],
                     ['en-IN', 'India'],
                     ['en-NZ', 'New Zealand'],
                     ['en-ZA', 'South Africa'],
                     ['en-GB', 'United Kingdom'],
                     ['en-US', 'United States']],
 ['Español',         ['es-AR', 'Argentina'],
                     ['es-BO', 'Bolivia'],
                     ['es-CL', 'Chile'],
                     ['es-CO', 'Colombia'],
                     ['es-CR', 'Costa Rica'],
                     ['es-EC', 'Ecuador'],
                     ['es-SV', 'El Salvador'],
                     ['es-ES', 'España'],
                     ['es-US', 'Estados Unidos'],
                     ['es-GT', 'Guatemala'],
                     ['es-HN', 'Honduras'],
                     ['es-MX', 'México'],
                     ['es-NI', 'Nicaragua'],
                     ['es-PA', 'Panamá'],
                     ['es-PY', 'Paraguay'],
                     ['es-PE', 'Perú'],
                     ['es-PR', 'Puerto Rico'],
                     ['es-DO', 'República Dominicana'],
                     ['es-UY', 'Uruguay'],
                     ['es-VE', 'Venezuela']],
 ['Euskara',         ['eu-ES']],
 ['Français',        ['fr-FR']],
 ['Galego',          ['gl-ES']],
 ['Hrvatski',        ['hr_HR']],
 ['IsiZulu',         ['zu-ZA']],
 ['Íslenska',        ['is-IS']],
 ['Italiano',        ['it-IT', 'Italia'],
                     ['it-CH', 'Svizzera']],
 ['Magyar',          ['hu-HU']],
 ['Nederlands',      ['nl-NL']],
 ['Norsk bokmål',    ['nb-NO']],
 ['Polski',          ['pl-PL']],
 ['Português',       ['pt-BR', 'Brasil'],
                     ['pt-PT', 'Portugal']],
 ['Română',          ['ro-RO']],
 ['Slovenčina',      ['sk-SK']],
 ['Suomi',           ['fi-FI']],
 ['Svenska',         ['sv-SE']],
 ['Türkçe',          ['tr-TR']],
 ['български',       ['bg-BG']],
 ['Pусский',         ['ru-RU']],
 ['Српски',          ['sr-RS']],
 ['한국어',            ['ko-KR']],
 ['中文',             ['cmn-Hans-CN', '普通话 (中国大陆)'],
                     ['cmn-Hans-HK', '普通话 (香港)'],
                     ['cmn-Hant-TW', '中文 (台灣)'],
                     ['yue-Hant-HK', '粵語 (香港)']],
 ['日本語',           ['ja-JP']],
 ['Lingua latīna',   ['la']]];

for (var i = 0; i < langs.length; i++) {
  //select_language.options[i] = new Option(langs[i][0], i);
}
//select_language.selectedIndex = 6;
updateCountry();
//select_dialect.selectedIndex = 6;
showInfo('info_start');

function updateCountry() {
  //for (var i = select_dialect.options.length - 1; i >= 0; i--) {
  //  select_dialect.remove(i);
  //}
  //var list = langs[6];
  //for (var i = 1; i < list.length; i++) {
  //  select_dialect.options.add(new Option(list[i][1], list[i][0]));
  //}
  //select_dialect.style.visibility = list[1].length == 1 ? 'hidden' : 'visible';
}

var create_email = false;
var final_transcript = '';
var recognizing = false;
var ignore_onend;
var start_timestamp;
if (!('webkitSpeechRecognition' in window)) {
  upgrade();
} else {
  start_button.style.display = 'inline-block';
  var recognition = new webkitSpeechRecognition();
  recognition.continuous = true;
  recognition.interimResults = false;

  recognition.onstart = function() {
    recognizing = true;
    showInfo('info_speak_now');
    start_img.src = CurDir+'micanimate.gif';

  };

  recognition.onerror = function(event) {
    if (event.error == 'no-speech') {
      start_img.src = CurDir+'mic.gif';
      showInfo('info_no_speech');
      ignore_onend = true;
    }
    if (event.error == 'audio-capture') {
      start_img.src = CurDir+'mic.gif';
      showInfo('info_no_microphone');
      ignore_onend = true;
    }
    if (event.error == 'not-allowed') {
      if (event.timeStamp - start_timestamp < 100) {
        showInfo('info_blocked');
      } else {
        showInfo('info_denied');
      }
      ignore_onend = true;
    }
  };

  recognition.onend = function() {
    recognizing = false;
    if (ignore_onend) {
      return;
    }
    start_img.src = CurDir+'mic.gif';
    if (!final_transcript) {
      showInfo('info_start');
      return;
    }
    showInfo('');
    if (window.getSelection) {
      window.getSelection().removeAllRanges();
      var range = document.createRange();
      range.selectNode(document.getElementById('final_span'));
      window.getSelection().addRange(range);
    }
    if (create_email) {
      create_email = false;
      createEmail();
    }
  };

  recognition.onresult = function(event) {
    var interim_transcript = '';
    if (typeof(event.results) == 'undefined') {
      recognition.onend = null;
      recognition.stop();
      upgrade();
      return;
    }
    for (var i = event.resultIndex; i < event.results.length; ++i) {
      if (event.results[i].isFinal) {
        final_transcript = event.results[i][0].transcript;
      } else {
        interim_transcript += event.results[i][0].transcript;
      }
    }
    final_transcript = capitalize(final_transcript);
    final_span.value = linebreak(final_transcript);


    document.getElementById('final_span').style.display = 'block';
	
	var My_Voice = $('#final_span').val().toLowerCase();
	To_Compare = To_Compare.replace(/\-/g, ' ');
	To_Compare = To_Compare.replace(/\_/g, ' ');
	if(My_Voice[0]==' ') My_Voice = My_Voice.replace(My_Voice[0], '');
	if(My_Voice[To_Compare.length-1]==' ') My_Voice = My_Voice.replace(To_Compare[My_Voice.length-1], '');
	if(IgnoreHamzaLetters(To_Compare,true)==IgnoreHamzaLetters(My_Voice,true)){
		SoundPlayer.stopAll();	

		 //tmp_cmpr = tmp_cmpr.replace(/ /g, '_');

			
		if(iOS){
			var FakeInput = $("<input type='text'/>");
			FakeInput.insertAfter("#final_span").focus()
		}
		setTimeout(function(){$("#FakeInput").remove();$('input#final_span, input.final1').val('').blur();},1000)

		$('#'+GlobTo_Compare).attr('class','Disabled_me').css({'opacity':'1'})		
		//$('.active_me').addClass('Disabled_me').removeClass('active_me');
		
		$('#'+GlobTo_Compare).data("MyjBox").close()
		$('#'+GlobTo_Compare).css({"cursor":"default"}).data("MyjBox").disable()
			
		var play_;
		//alert(Play_Me+' - '+Index_Me)
		//	var to_play = Sounds[Global-1].split(';;')

		setTimeout(function(){
			if(Index_Me<(Play_Me.length-1))
				Index_Me++;
			else	
				Index_Me = 0;
			Click_To_Play();
		},1200)

		var snd_me = SoundPlayer.createSound({url:ComDir+'Common/common_A2014/snd_true.mp3'});	
		snd_me.play();	

							
		$('#ItemCounter').html(NumbersToArabic($('.Disabled_me').length))

		if($('.Disabled_me').length==(Play_Me.length) ){
			setTimeout(function(){
				document.getElementById('final_span').value = '';		
				document.getElementById('final_span').style.display = 'none';		
				$('#FeedBack').css('display','block');	
				$('.hotspot_').css('color','#414042');			
				$('#Mine_Just').css('display','none');	
				$('#Clear_Meo, .compact.marquee').css('display','none');	
				$(".switch_holder2>label").show()
				for(var a=0;a<Data.length;a++){
					$('#'+Data[a]).stop().css({'opacity':1,'stroke':'none'})
					.css({"cursor":"pointer"}).data("MyjBox").enable()
				}
				
			},1000)
			
		}
	}
		
	
   // final_span.style.display = 'none';
    //interim_span.innerHTML = linebreak(interim_transcript);
    if (final_transcript || interim_transcript) {
      showButtons('inline-block');
    }
  };
}

function upgrade() {
  start_button.style.visibility = 'hidden';
  showInfo('info_upgrade');
}

var two_line = /\n\n/g;
var one_line = /\n/g;
function linebreak(s) {
  return s.replace(two_line, '<p></p>').replace(one_line, '<br>');
}

var first_char = /\S/;
function capitalize(s) {
  return s.replace(first_char, function(m) { return m.toUpperCase(); });
}

function createEmail() {}

function copyButton() {}


function startButton(event) {
  if (recognizing) {
    recognition.stop();
    return;
  }
  final_transcript = '';
  recognition.lang =  MyDir == 'rtl' ?  'ar-LB' : 'en-GB';
  recognition.start();
  ignore_onend = false;
  $("#final_span").prop("disabled",false).focus();
  final_span.value = '';
  interim_span.value = '';
  start_img.src = CurDir+'micslash.gif';
  showInfo('info_allow');
  showButtons('none');
  start_timestamp = event.timeStamp;
}

function clearValue_(){
  final_span.value = '';
  interim_span.value = '';
};


function showInfo(s) {}
function emailButton() {}
var current_style;
function showButtons(style) {}
